Index: /palm/trunk/SOURCE/Makefile
===================================================================
--- /palm/trunk/SOURCE/Makefile	(revision 4365)
+++ /palm/trunk/SOURCE/Makefile	(revision 4366)
@@ -25,4 +25,7 @@
 # -----------------
 # $Id$
+# add dependency on fft for transpose
+# 
+# 4347 2019-12-18 13:18:33Z suehring
 # add dependency to basic_constants_and_equations_mod for dynamics_mod
 # 
@@ -1160,4 +1163,5 @@
 transpose.o: \
 	cpulog_mod.o \
+	fft_xy_mod.o \
 	mod_kinds.o \
 	modules.o
Index: /palm/trunk/SOURCE/fft_xy_mod.f90
===================================================================
--- /palm/trunk/SOURCE/fft_xy_mod.f90	(revision 4365)
+++ /palm/trunk/SOURCE/fft_xy_mod.f90	(revision 4366)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Vectorized Temperton-fft added
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -41,4 +44,5 @@
 !> Fast Fourier transformation along x and y for 1d domain decomposition along x.
 !> Original version: Klaus Ketelsen (May 2002)
+!> @todo openmp support for vectorized Temperton fft
 !------------------------------------------------------------------------------!
  MODULE fft_xy
@@ -46,5 +50,5 @@
 
     USE control_parameters,                                                    &
-        ONLY:  fft_method, message_string
+        ONLY:  fft_method, loop_optimization, message_string
         
     USE cuda_fft_interfaces
@@ -52,5 +56,5 @@
     USE indices,                                                               &
         ONLY:  nx, ny, nz
-        
+
 #if defined( __cuda_fft )
     USE ISO_C_BINDING
@@ -72,10 +76,11 @@
 
     PRIVATE
-    PUBLIC fft_x, fft_x_1d, fft_y, fft_y_1d, fft_init, fft_x_m, fft_y_m
+    PUBLIC fft_x, fft_x_1d, fft_y, fft_y_1d, fft_init, fft_x_m, fft_y_m, f_vec, temperton_fft_vec
 
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE, SAVE ::  ifax_x  !<
     INTEGER(iwp), DIMENSION(:), ALLOCATABLE, SAVE ::  ifax_y  !<
 
-    LOGICAL, SAVE ::  init_fft = .FALSE.  !<
+    LOGICAL, SAVE ::  init_fft = .FALSE.           !<
+    LOGICAL, SAVE ::  temperton_fft_vec = .FALSE.  !<
 
     REAL(wp), SAVE ::  dnx      !<
@@ -86,4 +91,6 @@
     REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  trigs_x  !< 
     REAL(wp), DIMENSION(:), ALLOCATABLE, SAVE ::  trigs_y  !<
+
+    REAL(wp), DIMENSION(:,:), ALLOCATABLE, SAVE ::  f_vec
 
 #if defined( __ibm )
@@ -200,4 +207,11 @@
        ENDIF
 
+!
+!--    Switch to tell the Poisson-solver that the vectorized version of Temperton-fft is to be used.
+       IF ( fft_method == 'temperton-algorithm' .AND. loop_optimization == 'vector' )  THEN
+          temperton_fft_vec = .TRUE.
+       ENDIF
+
+
 #if defined( _OPENACC ) && defined( __cuda_fft )
        fft_method = 'system-specific'
@@ -270,4 +284,10 @@
           CALL set99( trigs_y, ifax_y, ny+1 )
 
+          IF ( temperton_fft_vec )  THEN
+             ALLOCATE( f_vec((nyn_x-nys_x+1)*(nzt_x-nzb_x+1),0:nx+2) )
+          ENDIF
+
+
+
        ELSEIF ( fft_method == 'fftw' )  THEN
 !
@@ -312,5 +332,5 @@
 !------------------------------------------------------------------------------!
  
-    SUBROUTINE fft_x( ar, direction, ar_2d )
+    SUBROUTINE fft_x( ar, direction, ar_2d, ar_inv )
 
 
@@ -325,4 +345,5 @@
        INTEGER(iwp) ::  j          !<
        INTEGER(iwp) ::  k          !<
+       INTEGER(iwp) ::  mm         !<
 
        LOGICAL ::  forward_fft !<
@@ -331,4 +352,10 @@
        REAL(wp), DIMENSION(nx+2)   ::  work1  !<
        
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE           ::  work_vec  !<
+       REAL(wp), DIMENSION(0:nx,nys_x:nyn_x), OPTIONAL ::  ar_2d     !<
+
+       REAL(wp), DIMENSION(nys_x:nyn_x,nzb_x:nzt_x,0:nx), OPTIONAL ::  ar_inv   !<
+       REAL(wp), DIMENSION(0:nx,nys_x:nyn_x,nzb_x:nzt_x)           ::  ar       !<
+
 #if defined( __ibm )
        REAL(wp), DIMENSION(nau2) ::  aux2  !< 
@@ -337,13 +364,7 @@
        REAL(wp), DIMENSION(6*(nx+1)) ::  work2  !<
 #elif defined( __cuda_fft )
-       COMPLEX(dp), DIMENSION(0:(nx+1)/2,nys_x:nyn_x,nzb_x:nzt_x) ::           &
-          ar_tmp  !<
+       COMPLEX(dp), DIMENSION(0:(nx+1)/2,nys_x:nyn_x,nzb_x:nzt_x) ::  ar_tmp  !<
        !$ACC DECLARE CREATE(ar_tmp)
 #endif
-
-       REAL(wp), DIMENSION(0:nx,nys_x:nyn_x), OPTIONAL   ::                    &
-          ar_2d   !<
-       REAL(wp), DIMENSION(0:nx,nys_x:nyn_x,nzb_x:nzt_x) ::                    &
-          ar      !<
 
 !
@@ -427,45 +448,133 @@
           IF ( forward_fft )  THEN
 
-             !$OMP PARALLEL PRIVATE ( work, work1, i, j, k )
-             !$OMP DO
-             DO  k = nzb_x, nzt_x
-                DO  j = nys_x, nyn_x
-
-                   work(0:nx) = ar(0:nx,j,k)
-                   CALL fft991cy( work, work1, trigs_x, ifax_x, 1, nx+1, nx+1, 1, -1 )
-
-                   DO  i = 0, (nx+1)/2
-                      ar(i,j,k) = work(2*i)
-                   ENDDO
-                   DO  i = 1, (nx+1)/2 - 1
-                      ar(nx+1-i,j,k) = work(2*i+1)
-                   ENDDO
-
-                ENDDO
-             ENDDO
-             !$OMP END PARALLEL
-
-          ELSE
-
-             !$OMP PARALLEL PRIVATE ( work, work1, i, j, k )
-             !$OMP DO
-             DO  k = nzb_x, nzt_x
-                DO  j = nys_x, nyn_x
-
-                   DO  i = 0, (nx+1)/2
-                      work(2*i) = ar(i,j,k)
-                   ENDDO
-                   DO  i = 1, (nx+1)/2 - 1
-                      work(2*i+1) = ar(nx+1-i,j,k)
-                   ENDDO
-                   work(1)    = 0.0_wp
-                   work(nx+2) = 0.0_wp
-
-                   CALL fft991cy( work, work1, trigs_x, ifax_x, 1, nx+1, nx+1, 1, 1 )
-                   ar(0:nx,j,k) = work(0:nx)
-
-                ENDDO
-             ENDDO
-             !$OMP END PARALLEL
+             IF ( .NOT. temperton_fft_vec )  THEN
+
+                !$OMP PARALLEL PRIVATE ( work, work1, i, j, k )
+                !$OMP DO
+                DO  k = nzb_x, nzt_x
+                   DO  j = nys_x, nyn_x
+
+                      work(0:nx) = ar(0:nx,j,k)
+                      CALL fft991cy( work, work1, trigs_x, ifax_x, 1, nx+1, nx+1, 1, -1 )
+
+                      DO  i = 0, (nx+1)/2
+                         ar(i,j,k) = work(2*i)
+                      ENDDO
+                      DO  i = 1, (nx+1)/2 - 1
+                         ar(nx+1-i,j,k) = work(2*i+1)
+                      ENDDO
+
+                   ENDDO
+                ENDDO
+                !$OMP END PARALLEL
+
+             ELSE
+
+!
+!--             Vector version of the Temperton-algorithm. Computes multiple 1-D FFT's.
+                ALLOCATE( work_vec( (nyn_x-nys_x+1)*(nzt_x-nzb_x+1),nx+2) )
+!
+!--             f_vec is already set in transpose_zx
+                CALL fft991cy_vec( f_vec, work_vec, trigs_x, ifax_x, nx+1, -1 )
+                DEALLOCATE( work_vec )
+
+                IF ( PRESENT( ar_inv ) )  THEN
+
+                   DO  k = nzb_x, nzt_x
+                      DO  j = nys_x, nyn_x
+                         mm = j-nys_x+1+(k-nzb_x)*(nyn_x-nys_x+1)
+                         DO  i = 0, (nx+1)/2
+                            ar_inv(j,k,i) = f_vec(mm,2*i)
+                         ENDDO
+                         DO  i = 1, (nx+1)/2-1
+                            ar_inv(j,k,nx+1-i) = f_vec(mm,2*i+1)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+
+                ELSE
+
+                   DO  k = nzb_x, nzt_x
+                      DO  j = nys_x, nyn_x
+                         mm = j-nys_x+1+(k-nzb_x)*(nyn_x-nys_x+1)
+                         DO  i = 0, (nx+1)/2
+                            ar(i,j,k) = f_vec(mm,2*i)
+                         ENDDO
+                         DO  i = 1, (nx+1)/2-1
+                            ar(nx+1-i,j,k) = f_vec(mm,2*i+1)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+
+                ENDIF
+
+             ENDIF
+
+          ELSE
+
+!
+!--          Backward fft
+             IF ( .NOT. temperton_fft_vec )  THEN
+
+                !$OMP PARALLEL PRIVATE ( work, work1, i, j, k )
+                !$OMP DO
+                DO  k = nzb_x, nzt_x
+                   DO  j = nys_x, nyn_x
+
+                      DO  i = 0, (nx+1)/2
+                         work(2*i) = ar(i,j,k)
+                      ENDDO
+                      DO  i = 1, (nx+1)/2 - 1
+                         work(2*i+1) = ar(nx+1-i,j,k)
+                      ENDDO
+                      work(1)    = 0.0_wp
+                      work(nx+2) = 0.0_wp
+
+                      CALL fft991cy( work, work1, trigs_x, ifax_x, 1, nx+1, nx+1, 1, 1 )
+                      ar(0:nx,j,k) = work(0:nx)
+
+                   ENDDO
+                ENDDO
+                !$OMP END PARALLEL
+
+             ELSE
+
+                IF ( PRESENT( ar_inv ) )  THEN
+
+                   DO  k = nzb_x, nzt_x
+                      DO  j = nys_x, nyn_x
+                         mm = j-nys_x+1+(k-nzb_x)*(nyn_x-nys_x+1)
+                         DO  i = 0, (nx+1)/2
+                            f_vec(mm,2*i) = ar_inv(j,k,i)
+                         ENDDO
+                         DO  i = 1, (nx+1)/2-1
+                            f_vec(mm,2*i+1) = ar_inv(j,k,nx+1-i)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+
+                ELSE
+
+                   DO  k = nzb_x, nzt_x
+                      DO  j = nys_x, nyn_x
+                         mm = j-nys_x+1+(k-nzb_x)*(nyn_x-nys_x+1)
+                         DO  i = 0, (nx+1)/2
+                            f_vec(mm,2*i) = ar(i,j,k)
+                         ENDDO
+                         DO  i = 1, (nx+1)/2-1
+                            f_vec(mm,2*i+1) = ar(nx+1-i,j,k)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+
+                ENDIF
+                f_vec(:,1)    = 0.0_wp
+                f_vec(:,nx+2) = 0.0_wp
+
+                ALLOCATE( work_vec((nyn_x-nys_x+1)*(nzt_x-nzb_x+1),nx+2) )
+                CALL fft991cy_vec( f_vec, work_vec, trigs_x, ifax_x, nx+1, 1 )
+                DEALLOCATE( work_vec )
+
+             ENDIF
 
           ENDIF
@@ -941,5 +1050,5 @@
  
     SUBROUTINE fft_y( ar, direction, ar_tr, nxl_y_bound, nxr_y_bound, nxl_y_l, &
-                      nxr_y_l )
+                      nxr_y_l, ar_inv )
 
 
@@ -952,4 +1061,5 @@
        INTEGER(iwp) ::  jshape(1)    !<
        INTEGER(iwp) ::  k            !<
+       INTEGER(iwp) ::  mm           !<
        INTEGER(iwp) ::  nxl_y_bound  !<
        INTEGER(iwp) ::  nxl_y_l      !<
@@ -962,4 +1072,11 @@
        REAL(wp), DIMENSION(ny+2)   ::  work1  !<
        
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  f_vec
+       REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  work_vec
+
+       REAL(wp), DIMENSION(0:ny,nxl_y_l:nxr_y_l,nzb_y:nzt_y)                   ::  ar      !<
+       REAL(wp), DIMENSION(nxl_y:nxr_y,nzb_y:nzt_y,0:ny), OPTIONAL             ::  ar_inv  !<
+       REAL(wp), DIMENSION(0:ny,nxl_y_bound:nxr_y_bound,nzb_y:nzt_y), OPTIONAL ::  ar_tr   !<
+
        COMPLEX(wp), DIMENSION(:), ALLOCATABLE ::  cwork  !<
        
@@ -975,8 +1092,4 @@
 #endif
 
-       REAL(wp), DIMENSION(0:ny,nxl_y_l:nxr_y_l,nzb_y:nzt_y)         ::        &
-          ar     !<
-       REAL(wp), DIMENSION(0:ny,nxl_y_bound:nxr_y_bound,nzb_y:nzt_y) ::        &
-          ar_tr  !<
 
        IF ( direction == 'forward' )  THEN
@@ -1057,45 +1170,153 @@
           IF ( forward_fft )  THEN
 
-             !$OMP PARALLEL PRIVATE ( work, work1, i, j, k )
-             !$OMP DO
-             DO  k = nzb_y, nzt_y
-                DO  i = nxl_y_l, nxr_y_l
-
-                   work(0:ny) = ar(0:ny,i,k)
-                   CALL fft991cy( work, work1, trigs_y, ifax_y, 1, ny+1, ny+1, 1, -1 )
-
-                   DO  j = 0, (ny+1)/2
-                      ar_tr(j,i,k) = work(2*j)
-                   ENDDO
-                   DO  j = 1, (ny+1)/2 - 1
-                      ar_tr(ny+1-j,i,k) = work(2*j+1)
-                   ENDDO
-
-                ENDDO
-             ENDDO
-             !$OMP END PARALLEL
-
-          ELSE
-
-             !$OMP PARALLEL PRIVATE ( work, work1, i, j, k )
-             !$OMP DO
-             DO  k = nzb_y, nzt_y
-                DO  i = nxl_y_l, nxr_y_l
-
-                   DO  j = 0, (ny+1)/2
-                      work(2*j) = ar_tr(j,i,k)
-                   ENDDO
-                   DO  j = 1, (ny+1)/2 - 1
-                      work(2*j+1) = ar_tr(ny+1-j,i,k)
-                   ENDDO
-                   work(1)    = 0.0_wp
-                   work(ny+2) = 0.0_wp
-
-                   CALL fft991cy( work, work1, trigs_y, ifax_y, 1, ny+1, ny+1, 1, 1 )
-                   ar(0:ny,i,k) = work(0:ny)
-
-                ENDDO
-             ENDDO
-             !$OMP END PARALLEL
+             IF ( .NOT. temperton_fft_vec )  THEN
+
+                !$OMP PARALLEL PRIVATE ( work, work1, i, j, k )
+                !$OMP DO
+                DO  k = nzb_y, nzt_y
+                   DO  i = nxl_y_l, nxr_y_l
+
+                      work(0:ny) = ar(0:ny,i,k)
+                      CALL fft991cy( work, work1, trigs_y, ifax_y, 1, ny+1, ny+1, 1, -1 )
+
+                      DO  j = 0, (ny+1)/2
+                         ar_tr(j,i,k) = work(2*j)
+                      ENDDO
+                      DO  j = 1, (ny+1)/2 - 1
+                         ar_tr(ny+1-j,i,k) = work(2*j+1)
+                      ENDDO
+
+                   ENDDO
+                ENDDO
+                !$OMP END PARALLEL
+
+             ELSE
+!
+!--             Vector version of Temperton-fft. Computes multiple 1-D FFT's.
+                ALLOCATE( f_vec((nxr_y_l-nxl_y_l+1)*(nzt_y-nzb_y+1),0:ny+2) )
+
+                mm = 1
+                DO  k = nzb_y, nzt_y
+                   DO  i = nxl_y_l, nxr_y_l
+                      f_vec(mm,0:nx) = ar(0:nx,i,k)
+                      mm = mm+1
+                   ENDDO
+                ENDDO
+
+                ALLOCATE( work_vec( (nxr_y_l-nxl_y_l+1)*(nzt_y-nzb_y+1),ny+2) )
+                CALL fft991cy_vec( f_vec, work_vec, trigs_y, ifax_y, ny+1, -1 )
+                DEALLOCATE( work_vec )
+
+                IF( PRESENT( ar_inv ) )  THEN
+
+                   DO  k = nzb_y, nzt_y
+                      DO  i = nxl_y_l, nxr_y_l
+                         mm = i-nxl_y_l+1+(k-nzb_y)*(nxr_y_l-nxl_y_l+1)
+                         DO  j = 0, (ny+1)/2
+                            ar_inv(i,k,j) = f_vec(mm,2*j)
+                         ENDDO
+                         DO  j = 1, (ny+1)/2 - 1
+                            ar_inv(i,k,ny+1-j) = f_vec(mm,2*j+1)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+
+                ELSE
+
+                   DO  k = nzb_y, nzt_y
+                      DO  i = nxl_y_l, nxr_y_l
+                         mm = i-nxl_y_l+1+(k-nzb_y)*(nxr_y_l-nxl_y_l+1)
+                         DO  j = 0, (ny+1)/2
+                            ar(j,i,k) = f_vec(mm,2*j)
+                         ENDDO
+                         DO  j = 1, (ny+1)/2 - 1
+                            ar(ny+1-j,i,k) = f_vec(mm,2*j+1)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+
+                ENDIF
+
+                DEALLOCATE( f_vec )
+
+             ENDIF
+
+          ELSE
+
+             IF ( .NOT. temperton_fft_vec )  THEN
+
+                !$OMP PARALLEL PRIVATE ( work, work1, i, j, k )
+                !$OMP DO
+                DO  k = nzb_y, nzt_y
+                   DO  i = nxl_y_l, nxr_y_l
+
+                      DO  j = 0, (ny+1)/2
+                         work(2*j) = ar_tr(j,i,k)
+                      ENDDO
+                      DO  j = 1, (ny+1)/2 - 1
+                         work(2*j+1) = ar_tr(ny+1-j,i,k)
+                      ENDDO
+                      work(1)    = 0.0_wp
+                      work(ny+2) = 0.0_wp
+
+                      CALL fft991cy( work, work1, trigs_y, ifax_y, 1, ny+1, ny+1, 1, 1 )
+                      ar(0:ny,i,k) = work(0:ny)
+
+                   ENDDO
+                ENDDO
+                !$OMP END PARALLEL
+
+             ELSE
+
+                ALLOCATE( f_vec((nxr_y_l-nxl_y_l+1)*(nzt_y-nzb_y+1),0:ny+2) )
+
+                IF ( PRESENT( ar_inv ) )  THEN
+
+                   DO  k = nzb_y, nzt_y
+                      DO  i = nxl_y_l, nxr_y_l
+                         mm = i-nxl_y_l+1+(k-nzb_y)*(nxr_y_l-nxl_y_l+1)
+                         DO  j = 0, (ny+1)/2
+                            f_vec(mm,2*j) = ar_inv(i,k,j)
+                         ENDDO
+                         DO  j = 1, (ny+1)/2 - 1
+                            f_vec(mm,2*j+1) = ar_inv(i,k,ny+1-j)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+
+                ELSE
+
+                   DO  k = nzb_y, nzt_y
+                      DO  i = nxl_y_l, nxr_y_l
+                         mm = i-nxl_y_l+1+(k-nzb_y)*(nxr_y_l-nxl_y_l+1)
+                         DO  j = 0, (ny+1)/2
+                            f_vec(mm,2*j) = ar(j,i,k)
+                         ENDDO
+                         DO  j = 1, (ny+1)/2 - 1
+                            f_vec(mm,2*j+1) = ar(ny+1-j,i,k)
+                         ENDDO
+                      ENDDO
+                   ENDDO
+
+                ENDIF
+
+                f_vec(:,1)    = 0.0_wp
+                f_vec(:,ny+2) = 0.0_wp
+
+                ALLOCATE( work_vec((nxr_y_l-nxl_y_l+1)*(nzt_y-nzb_y+1),ny+2) )
+                CALL fft991cy_vec( f_vec, work_vec, trigs_y, ifax_y, ny+1, 1 )
+                DEALLOCATE( work_vec )
+
+                mm = 1
+                DO  k = nzb_y, nzt_y
+                   DO  i = nxl_y_l, nxr_y_l
+                      ar(0:ny,i,k) = f_vec(mm,0:ny)
+                      mm = mm+1
+                   ENDDO
+                ENDDO
+
+                DEALLOCATE( f_vec )
+
+             ENDIF
 
           ENDIF
Index: /palm/trunk/SOURCE/poisfft_mod.f90
===================================================================
--- /palm/trunk/SOURCE/poisfft_mod.f90	(revision 4365)
+++ /palm/trunk/SOURCE/poisfft_mod.f90	(revision 4366)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! modification concerning NEC vectorizatio
+! 
+! 4360 2020-01-07 11:25:50Z suehring
 ! Corrected "Former revisions" section
 ! 
@@ -50,5 +53,6 @@
 
     USE fft_xy,                                                                &
-        ONLY:  fft_init, fft_y, fft_y_1d, fft_y_m, fft_x, fft_x_1d, fft_x_m
+        ONLY:  fft_init, fft_y, fft_y_1d, fft_y_m, fft_x, fft_x_1d, fft_x_m,   &
+               temperton_fft_vec
 
     USE indices,                                                               &
@@ -207,5 +211,12 @@
 
           CALL cpu_log( log_point_s(4), 'fft_x', 'start' )
-          CALL fft_x( ar, 'forward' )
+          IF ( temperton_fft_vec )  THEN
+!
+!--          Vector version outputs a transformed array ar_inv that does not require resorting
+!--          (which is done for ar further below)
+             CALL fft_x( ar, 'forward',  ar_inv=ar_inv)
+          ELSE
+             CALL fft_x( ar, 'forward')
+          ENDIF
           CALL cpu_log( log_point_s(4), 'fft_x', 'pause' )
 
@@ -213,12 +224,19 @@
 !--       Transposition x --> y
           CALL cpu_log( log_point_s(5), 'transpo forward', 'continue' )
-          CALL resort_for_xy( ar, ar_inv )
+          IF( .NOT. temperton_fft_vec )  CALL resort_for_xy( ar, ar_inv )
           CALL transpose_xy( ar_inv, ar )
           CALL cpu_log( log_point_s(5), 'transpo forward', 'pause' )
 
           CALL cpu_log( log_point_s(7), 'fft_y', 'start' )
-          CALL fft_y( ar, 'forward', ar_tr = ar,                &
-                      nxl_y_bound = nxl_y, nxr_y_bound = nxr_y, &
-                      nxl_y_l = nxl_y, nxr_y_l = nxr_y )
+          IF ( temperton_fft_vec )  THEN
+!
+!--          Input array ar_inv from fft_x can be directly used here.
+!--          The output (also in array ar_inv) does not require resorting below.
+             CALL fft_y( ar, 'forward', ar_inv = ar_inv, nxl_y_bound = nxl_y, nxr_y_bound = nxr_y, &
+                         nxl_y_l = nxl_y, nxr_y_l = nxr_y )
+          ELSE
+             CALL fft_y( ar, 'forward', ar_tr = ar, nxl_y_bound = nxl_y, nxr_y_bound = nxr_y,      &
+                         nxl_y_l = nxl_y, nxr_y_l = nxr_y )
+          ENDIF
           CALL cpu_log( log_point_s(7), 'fft_y', 'pause' )
 
@@ -226,5 +244,5 @@
 !--       Transposition y --> z
           CALL cpu_log( log_point_s(5), 'transpo forward', 'continue' )
-          CALL resort_for_yz( ar, ar_inv )
+          IF ( .NOT. temperton_fft_vec )  CALL resort_for_yz( ar, ar_inv )
           CALL transpose_yz( ar_inv, ar )
           CALL cpu_log( log_point_s(5), 'transpo forward', 'stop' )
@@ -241,11 +259,21 @@
           CALL cpu_log( log_point_s(8), 'transpo invers', 'start' )
           CALL transpose_zy( ar, ar_inv )
-          CALL resort_for_zy( ar_inv, ar )
+!
+!--       The fft_y below (vector branch) can directly process ar_inv (i.e. does not require a
+!--       resorting)
+          IF ( .NOT. temperton_fft_vec )  CALL resort_for_zy( ar_inv, ar )
           CALL cpu_log( log_point_s(8), 'transpo invers', 'pause' )
 
           CALL cpu_log( log_point_s(7), 'fft_y', 'continue' )
-          CALL fft_y( ar, 'backward', ar_tr = ar,               &
-                      nxl_y_bound = nxl_y, nxr_y_bound = nxr_y, &
-                      nxl_y_l = nxl_y, nxr_y_l = nxr_y )
+          IF ( temperton_fft_vec )  THEN
+!
+!--          Output array ar_inv can be used as input to the below fft_x routine without resorting
+             CALL fft_y( ar, 'backward', ar_inv = ar_inv, nxl_y_bound = nxl_y, nxr_y_bound = nxr_y,&
+                         nxl_y_l = nxl_y, nxr_y_l = nxr_y )
+          ELSE
+             CALL fft_y( ar, 'backward', ar_tr = ar, nxl_y_bound = nxl_y, nxr_y_bound = nxr_y,     &
+                         nxl_y_l = nxl_y, nxr_y_l = nxr_y )
+          ENDIF
+
           CALL cpu_log( log_point_s(7), 'fft_y', 'stop' )
 
@@ -254,9 +282,13 @@
           CALL cpu_log( log_point_s(8), 'transpo invers', 'continue' )
           CALL transpose_yx( ar, ar_inv )
-          CALL resort_for_yx( ar_inv, ar )
+          IF ( .NOT. temperton_fft_vec )  CALL resort_for_yx( ar_inv, ar )
           CALL cpu_log( log_point_s(8), 'transpo invers', 'pause' )
 
           CALL cpu_log( log_point_s(4), 'fft_x', 'continue' )
-          CALL fft_x( ar, 'backward' )
+          IF ( temperton_fft_vec )  THEN
+             CALL fft_x( ar, 'backward',  ar_inv=ar_inv )
+          ELSE
+             CALL fft_x( ar, 'backward' )
+          ENDIF
           CALL cpu_log( log_point_s(4), 'fft_x', 'stop' )
 
